searchNodes=[{"doc":"A date-time parser using Calendar.strftime/3 format strings.","ref":"Datix.html","title":"Datix","type":"module"},{"doc":"Like compile/1 , but returns the compiled struct directly or raises in case of errors. Examples iex&gt; Datix . compile! ( &quot;%Y-%m-%d&quot; ) Datix . compile! ( &quot;%Y-%m-%d&quot; ) iex&gt; Datix . compile! ( &quot;%l&quot; ) ** (Datix.FormatStringError) invalid format string because of invalid modifier: %l","ref":"Datix.html#compile!/1","title":"Datix.compile!/1","type":"function"},{"doc":"Compiles the given format string. If the format string is a valid format string, then this function returns {:ok, compiled} . compiled is a term that represents a compiled format (its internal representation is private). You can pass a compiled/0 term to strptime/3 and such. If the format string is invalid, this function returns {:error, reason} , where reason is an exception struct . You can use this function for two reasons: You have the same format string that you want to compile once and then use to parse over and over You want to validate a format string","ref":"Datix.html#compile/1","title":"Datix.compile/1","type":"function"},{"doc":"Parses a date-time string according to the given format , erroring out for invalid arguments.","ref":"Datix.html#strptime!/3","title":"Datix.strptime!/3","type":"function"},{"doc":"Parses a date-time string according to the given format . See the Calendar.strftime/3 documentation for how to specify a format string. format can be a format string or, since v0.2.0 of the library, a compiled format as returned by compile/1 . If parsing is successful, this function returns {:ok, datix} where datix is a map of type t/0 . If you are looking for functions that return Elixir structs (such as DateTime and similar), see Datix.DateTime , Datix.Date , Datix.Time , and Datix.NaiveDateTime . If there's an error, this function returns {:error, error} where error is an exception struct . You can raise it manually with raise/1 . Options :preferred_date - a string for the preferred format to show dates, it can't contain the %x format and defaults to &quot;%Y-%m-%d&quot; if the option is not received :month_names - a list of the month names, if the option is not received it defaults to a list of month names in English :abbreviated_month_names - a list of abbreviated month names, if the option is not received it defaults to a list of abbreviated month names in English :day_of_week_names - a list of day names, if the option is not received it defaults to a list of day names in English :abbreviated_day_of_week_names - a list of abbreviated day names, if the option is not received it defaults to a list of abbreviated day names in English :preferred_time - a string for the preferred format to show times, it can't contain the %X format and defaults to &quot;%H:%M:%S&quot; if the option is not received :am_pm_names - a keyword list with the names of the period of the day, defaults to [am: &quot;am&quot;, pm: &quot;pm&quot;] . Examples iex&gt; Datix . strptime ( &quot;2021/01/10&quot; , &quot;%Y/%m/%d&quot; ) { :ok , %{ day : 10 , month : 1 , year : 2021 } } iex&gt; Datix . strptime ( &quot;21/01/10&quot; , &quot;%y/%m/%d&quot; ) { :ok , %{ day : 10 , month : 1 , year_2_digit : 21 } } iex&gt; Datix . strptime ( &quot;13/14/15&quot; , &quot;%H/%M/%S&quot; ) { :ok , %{ hour : 13 , minute : 14 , second : 15 } } iex&gt; Datix . strptime ( &quot;1 PM&quot; , &quot;%-I %p&quot; ) { :ok , %{ am_pm : :pm , hour_12 : 1 } } iex&gt; Datix . strptime ( &quot;Tuesday&quot; , &quot;%A&quot; ) { :ok , %{ day_of_week : 2 } } iex&gt; Datix . strptime ( &quot;Tue&quot; , &quot;%a&quot; ) { :ok , %{ day_of_week : 2 } } iex&gt; Datix . strptime ( &quot;Di&quot; , &quot;%a&quot; , ...&gt; abbreviated_day_of_week_names : ~w(Mo Di Mi Do Fr Sa So) ) { :ok , %{ day_of_week : 2 } } iex&gt; compiled = Datix . compile! ( &quot;%Y/%m/%d&quot; ) iex&gt; Datix . strptime ( &quot;2021/01/10&quot; , compiled ) { :ok , %{ day : 10 , month : 1 , year : 2021 } } iex&gt; Datix . strptime ( &quot;irrelevant&quot; , &quot;%l&quot; ) { :error , % Datix.FormatStringError { reason : { :invalid_modifier , &quot;%l&quot; } } }","ref":"Datix.html#strptime/3","title":"Datix.strptime/3","type":"function"},{"doc":"An opaque type representing a compiled format. The struct representation is internal and could change in the future without notice.","ref":"Datix.html#t:compiled/0","title":"Datix.compiled/0","type":"opaque"},{"doc":"","ref":"Datix.html#t:t/0","title":"Datix.t/0","type":"type"},{"doc":"A Date parser using Calendar.strftime/3 format strings.","ref":"Datix.Date.html","title":"Datix.Date","type":"module"},{"doc":"Parses a date string according to the given format , erroring out for invalid arguments. Options Accepts the same options as listed for parse/3 .","ref":"Datix.Date.html#parse!/3","title":"Datix.Date.parse!/3","type":"function"},{"doc":"Parses a date string according to the given format . See the Calendar.strftime/3 documentation for how to specify a format-string. Options :calendar - the calendar to build the Date , defaults to Calendar.ISO :preferred_date - a string for the preferred format to show dates, it can't contain the %x format and defaults to &quot;%Y-%m-%d&quot; if the option is not received :month_names - a list of the month names, if the option is not received it defaults to a list of month names in English :abbreviated_month_names - a list of abbreviated month names, if the option is not received it defaults to a list of abbreviated month names in English :day_of_week_names - a list of day names, if the option is not received it defaults to a list of day names in English :abbreviated_day_of_week_names - a list of abbreviated day names, if the option is not received it defaults to a list of abbreviated day names in English :pivot_year - a 2-digit year that represents the pivot year to use when %y is used. %y represents a 2-digit year, but Datix doesn't assume anything about which century such year refers to. For this reason, the :pivot_year option is required whenever %y is present in the format string; if not present, this function returns {:error, %Datix.OptionError{}} . For example, if pivot_year: 65 , then the 2-digit year 64 and lower will refer to the current century ( 2064 and so on at the time of writing this), while the 2-digit year 65 and higher will refer to the previous century ( 1965 and so on). Missing values will be set to minimum. Examples iex&gt; Datix.Date . parse ( &quot;2022-05-11&quot; , &quot;%x&quot; ) { :ok , ~D[2022-05-11] } iex&gt; Datix.Date . parse ( &quot;2021/01/10&quot; , &quot;%Y/%m/%d&quot; ) { :ok , ~D[2021-01-10] } iex&gt; format = Datix . compile! ( &quot;%Y/%m/%d&quot; ) iex&gt; Datix.Date . parse ( &quot;2021/01/10&quot; , format ) { :ok , ~D[2021-01-10] } iex&gt; Datix.Date . parse ( &quot;2021/01/10&quot; , &quot;%x&quot; , preferred_date : &quot;%Y/%m/%d&quot; ) { :ok , ~D[2021-01-10] } iex&gt; Datix.Date . parse ( &quot;18&quot; , &quot;%y&quot; , pivot_year : 50 ) { :ok , ~D[2018-01-01] } iex&gt; Datix.Date . parse ( &quot;18&quot; , &quot;%y&quot; , pivot_year : 15 ) { :ok , ~D[1918-01-01] } iex&gt; Datix.Date . parse ( &quot;18&quot; , &quot;%y&quot; ) { :error , % Datix.OptionError { reason : :missing , option : :pivot_year } } iex&gt; Datix.Date . parse ( &quot;&quot; , &quot;&quot; ) { :ok , ~D[0000-01-01] } iex&gt; Datix.Date . parse ( &quot;1736/13/03&quot; , &quot;%Y/%m/%d&quot; , calendar : Coptic ) { :ok , ~D[1736-13-03 Cldr.Calendar.Coptic] } iex&gt; Datix.Date . parse ( &quot;Mi, 1.4.2020&quot; , &quot;%a, %-d.%-m.%Y&quot; , ...&gt; abbreviated_day_of_week_names : ~w(Mo Di Mi Do Fr Sa So) ) { :ok , ~D[2020-04-01] } iex&gt; Datix.Date . parse ( &quot;Fr, 1.4.2020&quot; , &quot;%a, %-d.%-m.%Y&quot; , ...&gt; abbreviated_day_of_week_names : ~w(Mo Di Mi Do Fr Sa So) ) { :error , % Datix.ValidationError { reason : :invalid_date , module : Datix.Date } }","ref":"Datix.Date.html#parse/3","title":"Datix.Date.parse/3","type":"function"},{"doc":"A DateTime parser using Calendar.strftime/3 format string.","ref":"Datix.DateTime.html","title":"Datix.DateTime","type":"module"},{"doc":"Parses a datetime string according to the given format , erroring out for invalid arguments. This function is just defined for UTC datetimes. Options Accepts the same options as listed for parse/3 . Examples iex&gt; Datix.DateTime . parse! ( &quot;2018/06/27 11:23:55 UTC+0000&quot; , &quot;%Y/%m/%d %H:%M:%S %Z%z&quot; ) ~U[2018-06-27 11:23:55Z] iex&gt; format = Datix . compile! ( &quot;%Y/%m/%d %H:%M:%S %Z%z&quot; ) iex&gt; Datix.DateTime . parse! ( &quot;2018/06/27 11:23:55 UTC+0000&quot; , format ) ~U[2018-06-27 11:23:55Z] iex&gt; Datix.DateTime . parse! ( &quot;2018/06/27 11:23:55 CEST+0200&quot; , &quot;%Y/%m/%d %H:%M:%S %Z%z&quot; ) ** (Datix.ValidationError) unknown timezone abbreviation: CEST","ref":"Datix.DateTime.html#parse!/3","title":"Datix.DateTime.parse!/3","type":"function"},{"doc":"Parses a datetime string into a DateTime according to the given format . See the Calendar.strftime/3 documentation for how to specify a format string. When the format string contains an offset ( %z ) or a timezone abbreviation ( %Z ), then the :time_zone option is required. See below for more information on the option. Options :calendar - the calendar to build the Date , defaults to Calendar.ISO :preferred_date - a string for the preferred format to show dates, it can't contain the %x format and defaults to &quot;%Y-%m-%d&quot; if the option is not received :month_names - a list of the month names, if the option is not received it defaults to a list of month names in English :abbreviated_month_names - a list of abbreviated month names, if the option is not received it defaults to a list of abbreviated month names in English :day_of_week_names - a list of day names, if the option is not received it defaults to a list of day names in English :abbreviated_day_of_week_names - a list of abbreviated day names, if the option is not received it defaults to a list of abbreviated day names in English :preferred_time - a string for the preferred format to show times, it can't contain the %X format and defaults to &quot;%H:%M:%S&quot; if the option is not received :am_pm_names - a keyword list with the names of the period of the day, defaults to [am: &quot;am&quot;, pm: &quot;pm&quot;] . :pivot_year - (since v0.2.0) a 2-digit year that represents the pivot year to use when %y is used. %y represents a 2-digit year, but Datix doesn't assume anything about which century such year refers to. For this reason, the :pivot_year option is required whenever %y is present in the format string; if not present, this function returns {:error, :missing_pivot_year_option} . For example, if pivot_year: 65 , then the 2-digit year 64 and lower will refer to the current century ( 2064 and so on at the time of writing this), while the 2-digit year 65 and higher will refer to the previous century ( 1965 and so on). :time_zone - (since v0.3.0) a function that receives the parsed datetime as NaiveDateTime , the zone abbreviation, and the offset to handle the time zone and returns an :ok tuple with the DateTime or an :error tuple with Datix.ValidationError . Defaults to a function handling only &quot;UTC&quot;. Examples iex&gt; Datix.DateTime . parse ( &quot;2021/01/10 12:14:24&quot; , &quot;%Y/%m/%d %H:%M:%S&quot; ) { :ok , ~U[2021-01-10 12:14:24Z] } iex&gt; format = Datix . compile! ( &quot;%Y/%m/%d %H:%M:%S&quot; ) iex&gt; Datix.DateTime . parse ( &quot;2021/01/10 12:14:24&quot; , format ) { :ok , ~U[2021-01-10 12:14:24Z] } iex&gt; Datix.DateTime . parse ( &quot;2018/06/27 11:23:55 CEST+0200&quot; , &quot;%Y/%m/%d %H:%M:%S %Z%z&quot; ) { :error , % Datix.ValidationError { module : Datix.DateTime , reason : { :unknown_timezone_abbr , &quot;CEST&quot; } } } If you need to parse non-UTC datetimes, you'll have to pass the :time_zone option. tz_fun = fn naive_datetime , abbr , offset -&gt; { :ok , naive_datetime |&gt; DateTime . from_naive! ( convert_abbr ( abbr ) ) |&gt; DateTime . add ( - offset ) } end Datix.DateTime . parse ( &quot;2018/06/27 11:23:55 CEST+0200&quot; , &quot;%Y/%m/%d %H:%M:%S %Z%z&quot; , time_zone : tz_fun )","ref":"Datix.DateTime.html#parse/3","title":"Datix.DateTime.parse/3","type":"function"},{"doc":"A NaiveDateTime parser using Calendar.strftime/3 format-string.","ref":"Datix.NaiveDateTime.html","title":"Datix.NaiveDateTime","type":"module"},{"doc":"Parses a datetime string according to the given format , erroring out for invalid arguments. Options Accepts the same options as listed for parse/3 .","ref":"Datix.NaiveDateTime.html#parse!/3","title":"Datix.NaiveDateTime.parse!/3","type":"function"},{"doc":"Parses a datetime string into a NaiveDateTime according to the given format . See the Calendar.strftime/3 documentation for how to specify a format string. Time zone information is ignored . Options :calendar - the calendar to build the Date , defaults to Calendar.ISO :preferred_date - a string for the preferred format to show dates, it can't contain the %x format and defaults to &quot;%Y-%m-%d&quot; if the option is not received :month_names - a list of the month names, if the option is not received it defaults to a list of month names in English :abbreviated_month_names - a list of abbreviated month names, if the option is not received it defaults to a list of abbreviated month names in English :day_of_week_names - a list of day names, if the option is not received it defaults to a list of day names in English :abbreviated_day_of_week_names - a list of abbreviated day names, if the option is not received it defaults to a list of abbreviated day names in English :preferred_time - a string for the preferred format to show times, it can't contain the %X format and defaults to &quot;%H:%M:%S&quot; if the option is not received :am_pm_names - a keyword list with the names of the period of the day, defaults to [am: &quot;am&quot;, pm: &quot;pm&quot;] . :pivot_year - a 2-digit year that represents the pivot year to use when %y is used. %y represents a 2-digit year, but Datix doesn't assume anything about which century such year refers to. For this reason, the :pivot_year option is required whenever %y is present in the format string; if not present, this function returns {:error, :missing_pivot_year_option} . For example, if pivot_year: 65 , then the 2-digit year 64 and lower will refer to the current century ( 2064 and so on at the time of writing this), while the 2-digit year 65 and higher will refer to the previous century ( 1965 and so on). Examples iex&gt; Datix.NaiveDateTime . parse ( &quot;2021/01/10 12:14:24&quot; , &quot;%Y/%m/%d %H:%M:%S&quot; ) { :ok , ~N[2021-01-10 12:14:24] } iex&gt; format = Datix . compile! ( &quot;%Y/%m/%d %H:%M:%S&quot; ) iex&gt; Datix.NaiveDateTime . parse ( &quot;2021/01/10 12:14:24&quot; , format ) { :ok , ~N[2021-01-10 12:14:24] } iex&gt; Datix.NaiveDateTime . parse ( &quot;2018/06/27 11:23:55 CEST+0200&quot; , &quot;%Y/%m/%d %H:%M:%S %Z%z&quot; ) { :ok , ~N[2018-06-27 11:23:55Z] } iex&gt; Datix.NaiveDateTime . parse ( &quot;21/11/22&quot; , &quot;%y/%m/%d&quot; , pivot_year : 50 ) { :ok , ~N[2021-11-22 00:00:00] } iex&gt; Datix.NaiveDateTime . parse ( &quot;21/11/22&quot; , &quot;%y/%m/%d&quot; , pivot_year : 20 ) { :ok , ~N[1921-11-22 00:00:00] }","ref":"Datix.NaiveDateTime.html#parse/3","title":"Datix.NaiveDateTime.parse/3","type":"function"},{"doc":"A Time parser using Calendar.strftime/3 format-string.","ref":"Datix.Time.html","title":"Datix.Time","type":"module"},{"doc":"Parses a date string according to the given format , erroring out for invalid arguments. Options Accepts the same options as listed for parse/3 .","ref":"Datix.Time.html#parse!/3","title":"Datix.Time.parse!/3","type":"function"},{"doc":"Parses a time string according to the given format . See the Calendar.strftime/3 documentation for how to specify a format string. Options :calendar - the calendar to build the Time , defaults to Calendar.ISO :preferred_time - a string for the preferred format to show times, it can't contain the %X format and defaults to &quot;%H:%M:%S&quot; if the option is not received :am_pm_names - a keyword list with the names of the period of the day, defaults to [am: &quot;am&quot;, pm: &quot;pm&quot;] . Missing values will be set to minimum. Examples iex&gt; Datix.Time . parse ( &quot;11:12:55&quot; , &quot;%X&quot; ) { :ok , ~T[11:12:55] } iex&gt; format = Datix . compile! ( &quot;%X&quot; ) iex&gt; Datix.Time . parse ( &quot;11:12:55&quot; , format ) { :ok , ~T[11:12:55] } iex&gt; Datix.Time . parse ( &quot;10 PM&quot; , &quot;%I %p&quot; ) { :ok , ~T[22:00:00] }","ref":"Datix.Time.html#parse/3","title":"Datix.Time.parse/3","type":"function"},{"doc":"An exception for when the format string is invalid.","ref":"Datix.FormatStringError.html","title":"Datix.FormatStringError","type":"exception"},{"doc":"","ref":"Datix.FormatStringError.html#t:reason/0","title":"Datix.FormatStringError.reason/0","type":"type"},{"doc":"","ref":"Datix.FormatStringError.html#t:t/0","title":"Datix.FormatStringError.t/0","type":"type"},{"doc":"An exception that represents an error with some options.","ref":"Datix.OptionError.html","title":"Datix.OptionError","type":"exception"},{"doc":"","ref":"Datix.OptionError.html#t:reason/0","title":"Datix.OptionError.reason/0","type":"type"},{"doc":"","ref":"Datix.OptionError.html#t:t/0","title":"Datix.OptionError.t/0","type":"type"},{"doc":"An exception for when there is an error parsing a string.","ref":"Datix.ParseError.html","title":"Datix.ParseError","type":"exception"},{"doc":"","ref":"Datix.ParseError.html#t:reason/0","title":"Datix.ParseError.reason/0","type":"type"},{"doc":"","ref":"Datix.ParseError.html#t:t/0","title":"Datix.ParseError.t/0","type":"type"},{"doc":"An exception for when a date or time fails validation. An &quot;invalid&quot; date or time is a date or time that gets parsed correctly, but that is semantically invalid. For example, a date with a day of 99 is invalid.","ref":"Datix.ValidationError.html","title":"Datix.ValidationError","type":"exception"},{"doc":"","ref":"Datix.ValidationError.html#t:reason/0","title":"Datix.ValidationError.reason/0","type":"type"},{"doc":"","ref":"Datix.ValidationError.html#t:t/0","title":"Datix.ValidationError.t/0","type":"type"}]